#!/usr/bin/env ruby
#
# This is a commmand line dice roller for RPG's like Dungeons & Dragons.
# Paul Gorman (gorman.paul@gmail.com) 13 October 2010
#

if ARGV.size != 1
  puts "Usage: #{$0} [v]NdN[+/-N][xN]"
  exit
end

term = ARGV[0]

version = '0.5'

def roll(term)
    total = 0
    verbose = FALSE
    result = term
    if term =~ /v.*/ # Use verbose mode.
        verbose = TRUE
        result = result.reverse.chop.reverse + ' = ('
    end
    term =~ /v?(\d*)d(\d+)\s*((\+|-)\s*(\d+))?\s*(x\s*\d+)?/
    if $1.to_i > 1 # Roll multiple dice.
        $1.to_i.times do
            roll = rand($2).to_i + 1
            total = total + roll
            if verbose
                result = result + ' ' + roll.to_s + ' '
            end
        end
    else
        total = rand($2).to_i + 1
        if verbose
            result = result + ' ' + total.to_s + ' '
        end
    end
    if $3 # Add bonus or penalty
        if $4 == '+'
            total = total + $5.to_i
        else
            total = total - $5.to_i
        end
        if verbose
            result = result + $3
        end
    end
    if verbose
        result = result + ')'
    end
    result = result + ' = ' + total.to_s
    return result
end

if term.strip =~ /^\s*(v?\s*\d*d\d+\s*((\+|-)\s*\d+)?)\s*$/
    # Throw dice.
    result = "Rolled " + roll($1) + "\n"
    print(result)
elsif term.strip =~ /^\s*(v?\s*\d*d\d+\s*((\+|-)\s*\d+)?)\s*(x\s*(\d+))?$/
    # Do multiple sets of throws. (Roll ability scores, etc.)
    result = "Rolled "
    $5.to_i.times do 
        result = result + roll($1) + "\n"
    end
    print(result)
elsif term.strip =~ /^.*$/
    # Huh? Display the help.
    print("\n==== Dice Roller (v#{version}) HELP ====\n'roll d6', 'roll 3d6', and 'roll 1d20+1' all work as expected.\n'roll v3d6' is verbose.\n'roll 3d6x6' rolls six sets of 3d6 results.\nEven 'roll v10d3+2x8' works.\n\n")
end
